const webpack = require('webpack');
const merge = require('webpack-merge');
const path = require('path');

var config = {
  output: {
    path: path.resolve(__dirname + '/dist/'),
  },
  module: {
    loaders: [
      {
        test: /\.js$/,
        loader: 'babel',
        include: __dirname,
        exclude: /node_modules/
      },
      {
        test: /\.vue$/,
        loader: 'vue'
      },
      {
        test: /\.css$/,
        loader: 'style!less!css'
      }
    ]
  },
  externals: {
    // put external libraries in here
  },
  plugins: [
    new webpack.optimize.UglifyJsPlugin( {
      minimize : true,
      sourceMap : false,
      mangle: true,
      compress: {
        warnings: false
      }
    } )
  ]
};

var componentName = 'ExampleComponent'
var fileName = componentName.replace(/([A-Z])/g, "-$1").toLowerCase().substr(1)

module.exports = [
  merge(config, {
    entry: path.resolve(__dirname + '/src/'+componentName+'.vue'),
    output: {
      filename: fileName+'.min.js',
      libraryTarget: 'window',
      library: componentName,
    }
  }),
  merge(config, {
    entry: path.resolve(__dirname + '/src/'+componentName+'.vue'),
    output: {
      filename: fileName+'.js',
      libraryTarget: 'umd',
      library: fileName,
      umdNamedDefine: true
    }
  })
];
